<?php
/*
Plugin Name: Social Discussions
Plugin URI: http://wwww.linksalpha.com/
Description: Show popularity of your blog posts on social networks such as twitter, facebook, google buzz, yahoo, and bitly. Also allow your users to share your blog posts on the above social networks.
Author: LinksAlpha
Author URI: http://linksalpha.com
Version: 1.0.2
*/

/*
    Copyright (C) 2010 LinksAlpha.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
require("social-discussions-utility-fns.php");
define('SOCIALDISCUSS_PLUGIN_URL', socialdiscuss_get_plugin_dir() );

function laecho_readOptionsValuesFromWPDatabase() {
	global $laecho_opt_counters_location, $laecho_opt_float, $laecho_disable_cntr_display;
	global $laecho_opt_twitter_icon, $laecho_opt_buzz_icon, $laecho_opt_bitly_icon, $laecho_opt_yahoo_icon;
	global $laecho_opt_margin_top, $laecho_opt_margin_right, $laecho_opt_margin_bottom, $laecho_opt_margin_left;
	global $laecho_opt_cntr_fb_likes, $laecho_opt_cntr_fb_comments;
	global $laecho_opt_cntr_yahoo_updates, $laecho_opt_cntr_bitly_clicks, $laecho_opt_cntr_google_buzz, $laecho_opt_cntr_min_val;	       
	global $laecho_opt_display_index_posts, $laecho_opt_display_archive_posts, $laecho_opt_display_page_posts;	
	$laecho_opt_counters_location = get_option('laecho-html-counters-location');
	$laecho_opt_float             = get_option('laecho-html-float');
	$laecho_opt_twitter_icon      = get_option('laecho-html-twitter-icon');
	$laecho_opt_buzz_icon         = get_option('laecho-html-buzz-icon');
	$laecho_opt_bitly_icon        = get_option('laecho-html-bitly-icon');
	$laecho_opt_yahoo_icon        = get_option('laecho-html-yahoo-icon');		
	$laecho_opt_margin_top        = get_option('laecho-html-margin-top');
	$laecho_opt_margin_right      = get_option('laecho-html-margin-right');
	$laecho_opt_margin_bottom     = get_option('laecho-html-margin-bottom');
	$laecho_opt_margin_left       = get_option('laecho-html-margin-left');
	$laecho_opt_cntr_fb_likes      = get_option('laecho-html-cntr-fb-likes');	
	$laecho_opt_cntr_fb_comments   = get_option('laecho-html-cntr-fb-comments');
	$laecho_opt_cntr_yahoo_updates = get_option('laecho-html-cntr-yahoo-updates');
	$laecho_opt_cntr_bitly_clicks  = get_option('laecho-html-cntr-bitly-clicks');
	$laecho_opt_cntr_google_buzz   = get_option('laecho-html-cntr-google-buzz');	
	$laecho_disable_cntr_display   = get_option('laecho-html-disable-cntr-display');	
	$laecho_opt_cntr_min_val       = get_option('laecho-html-cntr-min-val');
	$laecho_opt_display_index_posts   = get_option('laecho-html-display-index-posts');
	$laecho_opt_display_archive_posts = get_option('laecho-html-display-archive-posts');
	$laecho_opt_display_page_posts    = get_option('laecho-html-display-page-posts');

}

function laecho_writeOptionsValuesToWPDatabase($option) {
	if($option == 'default') {
		update_option('laecho-html-counters-location', 'after');						
		update_option('laecho-html-float', 'float:left');
		update_option('laecho-html-twitter-icon', '1');
		update_option('laecho-html-buzz-icon',    '1');		
		update_option('laecho-html-bitly-icon',   '1');
		update_option('laecho-html-yahoo-icon',   '1');
		update_option('laecho-html-margin-top',    '0');
		update_option('laecho-html-margin-right',  '0');
		update_option('laecho-html-margin-bottom', '0');
		update_option('laecho-html-margin-left',   '0');
		update_option('laecho-html-cntr-fb-likes',      '0');		
		update_option('laecho-html-cntr-fb-comments',   '0');
		update_option('laecho-html-cntr-yahoo-updates', '0');
		update_option('laecho-html-cntr-bitly-clicks',  '0');
		update_option('laecho-html-cntr-google-buzz',   '0');
		update_option('laecho-html-cntr-min-val', '-1');
		update_option('laecho-html-disable-cntr-display', '0');		
		update_option('laecho-html-display-index-posts',   '0');
		update_option('laecho-html-display-archive-posts', '0');
		update_option('laecho-html-display-page-posts',    '0');
	}
	else if ($option == 'update')
	{
		update_option('laecho-html-counters-location', $_POST['laecho-html-counters-location']);						
		update_option('laecho-html-float',             $_POST['laecho-html-float']);
		update_option('laecho-html-twitter-icon',      $_POST['laecho-html-twitter-icon']);
		update_option('laecho-html-buzz-icon',         $_POST['laecho-html-buzz-icon']);		
		update_option('laecho-html-bitly-icon',        $_POST['laecho-html-bitly-icon']);
		update_option('laecho-html-yahoo-icon',        $_POST['laecho-html-yahoo-icon']);
	    update_option('laecho-html-margin-top',    (string)$_POST['laecho-html-margin-top']);
	    update_option('laecho-html-margin-right',  (string)$_POST['laecho-html-margin-right']);
	    update_option('laecho-html-margin-bottom', (string)$_POST['laecho-html-margin-bottom']);
	    update_option('laecho-html-margin-left',   (string)$_POST['laecho-html-margin-left']);
		if(!empty($_POST['laecho-html-cntr-fb-likes'])) {
			update_option('laecho-html-cntr-fb-likes',      (string)$_POST['laecho-html-cntr-fb-likes']);
		}		
		else {
			update_option('laecho-html-cntr-fb-likes', '0');			
		}	
		
		if(!empty($_POST['laecho-html-cntr-fb-comments'])) {
		update_option('laecho-html-cntr-fb-comments',   (string)$_POST['laecho-html-cntr-fb-comments']);
		}
		else {
			update_option('laecho-html-cntr-fb-comments', '0');			
		}	
						
		if(!empty($_POST['laecho-html-cntr-yahoo-updates'])) {
		update_option('laecho-html-cntr-yahoo-updates', (string)$_POST['laecho-html-cntr-yahoo-updates']);
		}
		else {
			update_option('laecho-html-cntr-yahoo-updates', '0');			
		}	
		
		if(!empty($_POST['laecho-html-cntr-bitly-clicks'])) {
		update_option('laecho-html-cntr-bitly-clicks',  (string)$_POST['laecho-html-cntr-bitly-clicks']);
		}
		else {
			update_option('laecho-html-cntr-bitly-clicks', '0');			
		}	
		
		if(!empty($_POST['laecho-html-cntr-google-buzz'])) {
		update_option('laecho-html-cntr-google-buzz',   (string)$_POST['laecho-html-cntr-google-buzz']);
		}
		else {
			update_option('laecho-html-cntr-google-buzz', '0');			
		}	
		
		if(!empty($_POST['laecho-html-disable-cntr-display'])) {
		update_option('laecho-html-disable-cntr-display',   (string)$_POST['laecho-html-disable-cntr-display']);
		}
		else {
			update_option('laecho-html-disable-cntr-display', '0');			
		}
			
		update_option('laecho-html-cntr-min-val',       (string)$_POST['laecho-html-cntr-min-val']);		
		
		// Options for selecting pages on which stats should show/not-show
	    update_option('laecho-html-display-index-posts',   ($_POST['laecho-html-display-index-posts']  =='1') ? '1':'0' );
	    update_option('laecho-html-display-archive-posts', ($_POST['laecho-html-display-archive-posts']=='1') ? '1':'0' );
	    update_option('laecho-html-display-page-posts',    ($_POST['laecho-html-display-page-posts']   =='1') ? '1':'0' );    
	}
	else {
		delete_option('laecho-html-counters-location');				
		delete_option('laecho-html-float'); 
		delete_option('laecho-html-twitter-icon');
		delete_option('laecho-html-buzz-icon');		
		delete_option('laecho-html-bitly-icon');
		delete_option('laecho-html-yahoo-icon');
		delete_option('laecho-html-margin-top');
		delete_option('laecho-html-margin-right');
		delete_option('laecho-html-margin-bottom');
		delete_option('laecho-html-margin-left');			
		delete_option('laecho-html-cntr-fb-likes');
		delete_option('laecho-html-cntr-fb-comments');
		delete_option('laecho-html-cntr-yahoo-updates');
		delete_option('laecho-html-cntr-bitly-clicks');
		delete_option('laecho-html-cntr-google-buzz');
		delete_option('laecho-html-disable-cntr-display');
		delete_option('laecho-html-cntr-min-val');
		delete_option('laecho-html-display-index-posts');
		delete_option('laecho-html-display-archive-posts');
		delete_option('laecho-html-display-page-posts');		
	}	
} 

function laecho_wp_filter_post_content ( $related_content ) {
	global $laecho_opt_counters_location;
	global $laecho_disable_cntr_display;
	$laecho_disable_cntr_display = get_option('laecho-html-disable-cntr-display');		
	if($laecho_disable_cntr_display == '1') {
		return $related_content;
	}	
	$laecho_opt_counters_location = get_option('laecho-html-counters-location');
	if (($laecho_opt_counters_location == "beforeTime") || ($laecho_opt_counters_location == "afterTime")) {
		return $related_content;	
	}
	else {
		if($laecho_opt_counters_location == "before"){
			return (laecho_wp_filter_content(FALSE).$related_content);				
		}
		else {
			return ($related_content.laecho_wp_filter_content(FALSE));			
		}					
	}	
}

function laecho_wp_filter_time_content ( $related_content ) {
	global $laecho_opt_counters_location;
	global $laecho_disable_cntr_display;
	$laecho_disable_cntr_display = get_option('laecho-html-disable-cntr-display');
	if($laecho_disable_cntr_display == '1') {
		return $related_content;
	}	
	$laecho_opt_counters_location = get_option('laecho-html-counters-location');	
	if (($laecho_opt_counters_location == "before") || ($laecho_opt_counters_location == "after")) {	
		return $related_content;	
	}
	else {	
		if($laecho_opt_counters_location == "beforeTime"){
			return (laecho_wp_filter_content(FALSE).$related_content);				
		}
		else {
			return ($related_content.laecho_wp_filter_content(FALSE));			
		}					
	}	
}

function laecho_wp_filter_content ($show=TRUE) {
    global $laecho_opt_counters_location, $laecho_opt_float, $laecho_disable_cntr_display;
    global $laecho_opt_twitter_icon, $laecho_opt_buzz_icon, $laecho_opt_bitly_icon, $laecho_opt_yahoo_icon;
	global $laecho_opt_margin_top, $laecho_opt_margin_right, $laecho_opt_margin_bottom, $laecho_opt_margin_left;
	global $laecho_opt_cntr_fb_likes, $laecho_opt_cntr_fb_comments;
	global $laecho_opt_cntr_yahoo_updates, $laecho_opt_cntr_bitly_clicks, $laecho_opt_cntr_google_buzz, $laecho_opt_cntr_min_val;
	global $laecho_opt_display_index_posts, $laecho_opt_display_archive_posts, $laecho_opt_display_page_posts;
	global $post;	
	$p          = $post;
	$title1     = $p->post_title ;
	$link1      = get_permalink($p);
	$blog_url   = get_bloginfo('wpurl');
	$blog_title = get_bloginfo('wp_title');
	laecho_readOptionsValuesFromWPDatabase();		
	$position = '';
	if( $laecho_disable_cntr_display == '0') {
		if (($laecho_opt_counters_location == "beforeTime") || ($laecho_opt_counters_location == "afterTime")) {
			$position = 'padding-right:'.$laecho_opt_margin_right.'px;padding-left:'.$laecho_opt_margin_left.'px;';	
		}
		else {
			$position = $laecho_opt_float .';padding-top:'.$laecho_opt_margin_top.'px;padding-right:'.$laecho_opt_margin_right.'px;padding-bottom:'.$laecho_opt_margin_bottom.'px;padding-left:'.$laecho_opt_margin_left.'px;';	
		}
	}
	if (is_single()  ||   (is_home() && ($laecho_opt_display_index_posts == 0))  || (is_archive() && ($laecho_opt_display_archive_posts == 0)))
	{
		$response = socialdiscuss_fetch_count($link1);
		if (!empty($response)) {	
			$laecho_link_share = "http://www.linksalpha.com/discuss?service=";		
			$title1     = urlencode($p->post_title);			
		    $link1      = urlencode(get_permalink($p));
		    	    
		    $response->link_short = urlencode($response->link_short);
		    
		    $laecho_display_cntrs = '<ul style="list-style-image:none;white-space: nowrap;'.$position.'" class="navigationBar">';
		    if($response->count_tweets > $laecho_opt_cntr_min_val) {		    	
				if($laecho_opt_twitter_icon == '1') {				
					$laecho_display_cntrs .= '<li><div><a target="_blank"; href="'.$laecho_link_share.'twitter&target='.$link1.'&url_short='.$response->link_short.'&title='.$title1.'"><img  class="laechoimg" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/t1.png" /></a><a href="'.$response->details_url.'#twitter" target="_blank">'.$response->count_tweets.'</a>&nbsp;</div></li>';
				}
				else {
					$laecho_display_cntrs .= '<li><div><a target="_blank"; href="'.$laecho_link_share.'twitter&target='.$link1.'&url_short='.$response->link_short.'&title='.$title1.'"><img class="laechoimg" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/t2.png"/></a><a href="'.$response->details_url.'#twitter" target="_blank">'.$response->count_tweets.'</a>&nbsp;</div></li>';
				}
		    }	
			
		    if($response->count_fb_shares > $laecho_opt_cntr_min_val) {			    				
			    $laecho_display_cntrs .= '&nbsp;<li><div><a target="_blank"; href="'.$laecho_link_share.'fb_share&target='.$link1.'"><img class="laechoimg" style="border:1px solid black" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/fbs.png" /></a><a href="'.$response->details_url.'#facebook" target="_blank">'.$response->count_fb_shares.'</a>';
		    }		    			
			
		    if($response->count_fb_likes > $laecho_opt_cntr_min_val) {
			    if($laecho_opt_cntr_fb_likes == '0') {
					$laecho_display_cntrs .= '&nbsp;<a target="_blank"; href="'.$laecho_link_share.'fb_like&target='.$link1.'"><img class="laechoimg" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/fbl.png" /></a><a href="'.$response->details_url.'#facebook" target="_blank">'.$response->count_fb_likes.'</a>'; 
			    }
		    }
		    
		    if($response->count_fb_comments > $laecho_opt_cntr_min_val) {			    
			    if($laecho_opt_cntr_fb_comments == '0') {
					$laecho_display_cntrs .= '&nbsp;<a target="_blank"; href="'.$laecho_link_share.'fb_comment&target='.$link1.'"><img class="laechoimg" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/fbc.png" /></a><a href="'.$response->details_url.'#facebook" target="_blank">'.$response->count_fb_comments.'</a>'; 
			    }
		    }
			
		    $laecho_display_cntrs .= '&nbsp;</div></li>';
		    
		    if($response->count_buzz_comments > $laecho_opt_cntr_min_val) {
			    if($laecho_opt_cntr_google_buzz == '0') {
			    	if($laecho_opt_buzz_icon == '1') {
			    		$laecho_display_cntrs .= '&nbsp;<li><div><a target="_blank"; href="'.$laecho_link_share.'buzz&target='.$link1.'"><img class="laechoimg" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/gb1.png" /></a><a href="'.$response->details_url.'#buzz" target="_blank">'.$response->count_buzz_comments.'</a>&nbsp;</div></li>';	    			
			    	}
			    	else {
						$laecho_display_cntrs .= '&nbsp;<li><div><a target="_blank"; href="'.$laecho_link_share.'buzz&target='.$link1.'"><img class="laechoimg" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/gb2.png" /></a>'.' '.'<a href="'.$response->details_url.'#buzz" target="_blank">'.$response->count_buzz_comments.'</a>&nbsp;</div></li>';	    	
			    	}	    	
			    }
		    }
		    
		    if($response->count_bitly_clicks > $laecho_opt_cntr_min_val) {
			    if($laecho_opt_cntr_bitly_clicks == '0') {
		    		if($laecho_opt_bitly_icon == '1') {
		    			$laecho_display_cntrs .= '&nbsp;<li><div><img class="laechoimg" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/b1.png" /><a href="'.$response->details_url.'#bitly" target="_blank">'.$response->count_bitly_clicks.'</a>&nbsp;</div></li>';
		    		}
		    		else {
						$laecho_display_cntrs .= '&nbsp;<li><div><img class="laechoimg" style="padding-bottom:4px"; src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/b2.png" /><a href="'.$response->details_url.'#bitly" target="_blank">'.$response->count_bitly_clicks.'</a>&nbsp;</div></li>';	    		
		    		}    	
			    }
		    }		    
		    
		    if($response->count_yahoo_updates > $laecho_opt_cntr_min_val) {
			    if($laecho_opt_cntr_yahoo_updates == '0') {			    	
			    	if($laecho_opt_yahoo_icon == '1') {
						$laecho_display_cntrs .= '<li><div><a target="_blank"; href="'.$laecho_link_share.'yahoo&target='.$link1.'"><img class="laechoimg" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/y1.png" /></a>&nbsp;<a href="'.$response->details_url.'#yahoo" target="_blank">'.$response->count_yahoo_updates.'</a>&nbsp;</div></li>';   	
			    	}
			    	else {
						$laecho_display_cntrs .= '<li><div><a target="_blank"; href="'.$laecho_link_share.'yahoo&target='.$link1.'"><img class="laechoimg" style="padding-bottom:4px;" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/y2.png" /></a><a href="'.$response->details_url.'#yahoo" target="_blank">'.$response->count_yahoo_updates.'</a>&nbsp;</div></li>';	    	
			    	}	    	
			    }
		    }
		    
		    $laecho_display_cntrs .= '</ul>';  
			if($show) {		
				echo $laecho_display_cntrs;
				return;		
			}				
		    return $laecho_display_cntrs;
		}
		else {
			return; 
		}
	}
	return;
}

function laecho_wp_admin_options_settings () {
	global $laecho_opt_counters_location, $laecho_opt_float, $laecho_disable_cntr_display;
	global $laecho_opt_twitter_icon, $laecho_opt_buzz_icon, $laecho_opt_bitly_icon, $laecho_opt_yahoo_icon;
	global $laecho_opt_margin_top, $laecho_opt_margin_right, $laecho_opt_margin_bottom, $laecho_opt_margin_left;
	global $laecho_opt_cntr_fb_likes, $laecho_opt_cntr_fb_comments;
	global $laecho_opt_cntr_yahoo_updates, $laecho_opt_cntr_bitly_clicks, $laecho_opt_cntr_google_buzz, $laecho_opt_cntr_min_val;	
    global $laecho_opt_display_index_posts, $laecho_opt_display_archive_posts, $laecho_opt_display_page_posts;
    if (isset($_POST['info_update']))
    {
    		laecho_writeOptionsValuesToWPDatabase('update');
    		echo '<div id="message" class="updated fade"><p><strong>Settings saved.</strong></p></div>';
			echo '</strong></p></div>';
	}
	laecho_readOptionsValuesFromWPDatabase();
	$blog_url   = get_bloginfo('wpurl'); 
	$t_icon1  = '<img border="0" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/t1.png">';	
	$t_icon2  = '<img border="0" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/t2.png">';
	$gb_icon1 = '<img border="0" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/gb1.png">';
	$gb_icon2 = '<img border="0" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/gb2.png">';
	$b_icon1  = '<img border="0" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/b1.png">';
	$b_icon2  = '<img border="0" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/b2.png">';
	$y_icon1  = '<img border="0" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/y1.png">';
	$y_icon2  = '<img border="0" src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/y2.png">';
	require("html/social-discussions-admin.html");		
}

function laecho_wp_admin() {
    if (function_exists('add_options_page')) {
        add_options_page('Social Discussions', 'Social Discussions', 10, __FILE__, 'laecho_wp_admin_options_settings');
    }
}

function laecho_deactivate() {
	laecho_writeOptionsValuesToWPDatabase('delete');
}

function laecho_activate() {
	laecho_writeOptionsValuesToWPDatabase('default');
}

function laecho_main() {
	register_activation_hook( __FILE__, 'laecho_activate' );	
	wp_register_style('socialdiscusscss', SOCIALDISCUSS_PLUGIN_URL.'html/social-discussions-post.css');
	wp_enqueue_style('socialdiscusscss');	
	add_filter ( 'the_content', 'laecho_wp_filter_post_content');
	add_action ( 'admin_menu', 'laecho_wp_admin') ;
	add_filter ( 'the_time', 'laecho_wp_filter_time_content');	
	register_deactivation_hook( __FILE__, 'laecho_deactivate' );	
}

laecho_main();

?>